﻿var navControlContainer;
var navControl;

$(document).ready(function () {
    CreateControl();
    Microsoft.Dynamics.NAV.InvokeExtensibilityMethod("AddInReady", null);
});

function SendData(dataUri) {
    if (dataUri == "") {
        $("#drop-img").css("display", "none");
        $("#drop-text").css("display", "table-cell");
        $("#drop-clear").css("display", "none");
    } else {
        $("#drop-img").css("display", "block");
        $("#drop-text").css("display", "none");
        $("#drop-clear").css("display", "table-cell");
        $("#drop-img").attr("src", dataUri);
    }
}

function CreateControl() {
    navControlContainer = $("#controlAddIn");
    navControlContainer.append('<div id="drop-files" ondragover="return false"><div id="drop-text">Drop Picture Here</div><img width="300" height="200" id="drop-img" /></div><div id="drop-clear">Delete Picture</div>');
    navControl = $("#drop-files");

    jQuery.event.props.push('dataTransfer');

    navControl.bind('drop', function(e) {
        var files = e.dataTransfer.files;
        $.each(files, function(index, file) {
            var fileReader = new FileReader();
            fileReader.onload = (function (file) {
                var arrayBuffer = fileReader.result;
                if (arrayBuffer.substr(0, 10) == "data:image") {
                    SendData(arrayBuffer);
                    Microsoft.Dynamics.NAV.InvokeExtensibilityMethod("DataRead", [arrayBuffer]);
                } else {
                    alert("Invalid data type. Image expected.");
                    return;
                }
            });

            fileReader.readAsDataURL(file);
        });
    });

    navControl.bind('dragenter', function (e) {
        e.dataTransfer.dragEffect = "copy";
        $(this).css({ 'background-color': 'steelblue', 'border': '4px dashed lightsteelblue' });
        return false;
    });
    navControl.bind('drop', function () {
        $(this).css({ 'background-color': 'aliceblue', 'border': '4px dashed lightsteelblue' });
        return false;
    });
    navControl.bind('dragleave', function () {
        $(this).css({ 'background-color': 'aliceblue', 'border': '4px dashed lightsteelblue' });
        return false;
    });

    $("#drop-clear").click(function(e) {
        Microsoft.Dynamics.NAV.InvokeExtensibilityMethod("ClearPicture", null);
    });
};

