var map = null;

function InitializeMap(controlId) {
    map = new VEMap(controlId);
    map.HideScalebar();
    map.onLoadMap = function () {
        Microsoft.Dynamics.NAV.InvokeExtensibilityMethod('MapLoaded', null);
    };
}

function LoadMap(latitude, longiture) {
    var mapOptions = new VEMapOptions();
    mapOptions.DashboardColor = "black";
    mapOptions.EnableSearchLogo = false;

    map.LoadMap(
        new VELatLong(latitude, longiture), // center
        1,                                  // zoom level 1-19
        VEMapStyle.Birdseye,                // map style
        false,                              // fixed map
        VEMapMode.Mode2D,                   // map mode
        true,                               // map mode switch
        0,                                  // tile buffer
        mapOptions                          // options
    );
}

function ShowMiniMap(show) {
    if (show)
        map.ShowMiniMap();
    else
        map.HideMiniMap();
}

function ShowPushpin(title, imageName) {
    map.Clear();

    if (title != '') {
        var point = map.GetCenter();
        var pushpin = map.AddPushpin(point);
        var imageUrl = Microsoft.Dynamics.NAV.GetImageResource(imageName);
        pushpin.SetCustomIcon("<div class='pushpin'><img src='" + imageUrl + "'/>" + title + "</div>");
    }
}
