﻿using System;
using Vjeko.BingUtils.Bing;

namespace Vjeko.BingUtils
{
    public class Geocoder
    {
        public static Location Geocode(string address, string applicationId)
        {
            try
            {
                GeocodeService svc = new GeocodeService
                {
                    Url = "http://dev.virtualearth.net/webservices/v1/geocodeservice/GeocodeService.svc",
                    UseDefaultCredentials = true
                };
                GeocodeResponse resp = svc.Geocode(new GeocodeRequest
                {
                    Credentials = new Credentials
                    {
                        ApplicationId = applicationId
                    },
                    Query = address
                });
                return new Location
                {
                    Latitude = resp.Results[0].Locations[0].Latitude,
                    Longitude = resp.Results[0].Locations[0].Longitude
                };
            }
            catch (Exception)
            {
                return new Location();
            }
        }
    }
}
