﻿using System;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Windows.Forms;
using Microsoft.Dynamics.Framework.UI.Extensibility;
using Microsoft.Dynamics.Framework.UI.Extensibility.WinForms;

namespace Vjeko.com.Extensibility
{
    [ControlAddInExport("Vjeko.com AnyControl")]
    public class AnyControl : WinFormsControlAddInBase
    {
        [ApplicationVisible]
        public Control InnerControl { get; set; }

        [ApplicationVisible]
        public Type ControlType { get; set; }

        [ApplicationVisible]
        public event EventHandler ControlAddInReady;

        [ApplicationVisible]
        public event EventHandler RequestControlType;

        [ApplicationVisible]
        [IndexerName("Property")]
        public object this[string name]
        {
            get
            {
                PropertyInfo info = ControlType.GetProperty(name);
                return info.GetValue(InnerControl);
            }
            set
            {
                PropertyInfo info = ControlType.GetProperty(name);
                info.SetValue(InnerControl, value);
            }
        }

        protected override Control CreateControl()
        {
            if (RequestControlType != null)
                RequestControlType(this, null);

            InnerControl = Activator.CreateInstance(ControlType) as Control;

            if (ControlAddInReady != null)
                ControlAddInReady(this, null);

            return InnerControl;
        }
    }
}

